import { easingDefinitionToFunction } from './easing.mjs';

function getOriginIndex(origin, total) {
    if (origin === "first") {
        return 0;
    }
    else {
        const lastIndex = total - 1;
        return origin === "last" ? lastIndex : lastIndex / 2;
    }
}
function stagger(duration = 0.1, { startDelay = 0, origin = 0, ease } = {}) {
    return (i, total) => {
        const originIndex = typeof origin === "number" ? origin : getOriginIndex(origin, total);
        const distance = Math.abs(originIndex - i);
        let delay = duration * distance;
        if (ease) {
            const maxDelay = total * duration;
            const easingFunction = easingDefinitionToFunction(ease);
            delay = easingFunction(delay / maxDelay) * maxDelay;
        }
        return startDelay + delay;
    };
}

export { getOriginIndex, stagger };
